=== debian/changelog ===
opentoonz-dmo (1.5.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 10 Apr 2021 18:58:17 +0200

opentoonz-dmo (1.4.0-dmo4) unstable; urgency=medium

  * Build with libmypaint0

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 12 May 2020 08:38:48 +0200

opentoonz-dmo (1.4.0-dmo3) unstable; urgency=medium

  * Build with libmypaint-1.6-1

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 30 Apr 2020 10:03:20 +0200

opentoonz-dmo (1.4.0-dmo2) unstable; urgency=medium

  * Build with libmypaint-1.5-1

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 11 Feb 2020 15:35:16 +0100

opentoonz-dmo (1.4.0-dmo1) unstable; urgency=medium

  * New upstream.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 02 Feb 2020 11:07:20 +0100

opentoonz-dmo (1.3.0-dmo4) unstable; urgency=medium

  * Build against qtbase-abi-5-12-5 and/or qtdeclarative-abi-5-12-5

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 23 Oct 2019 13:21:24 +0200

opentoonz-dmo (1.3.0-dmo3) unstable; urgency=medium

  * Rebuild against libmypaint-1.4-0

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 16 Sep 2019 11:32:14 +0200

opentoonz-dmo (1.3.0-dmo2) unstable; urgency=medium

  * Rebuild against libjson-c4

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 08 Aug 2019 15:10:39 +0200

opentoonz-dmo (1.3.0-dmo1) unstable; urgency=medium

  * New upstream.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 30 Jan 2019 11:29:00 +0100

opentoonz-dmo (1.3.0~rc2-dmo1) unstable; urgency=medium

  * New upstream RC release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 23 Jan 2019 14:44:56 +0100

opentoonz-dmo (1.3.0~rc-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 08 Jan 2019 09:04:40 +0100

opentoonz-dmo (1.2.1-dmo2) unstable; urgency=medium

  * Rebuild against libglew2.1

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 18 Nov 2018 16:44:57 +0100

opentoonz-dmo (1.2.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 28 Jun 2018 08:00:40 +0200

opentoonz-dmo (1.2.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 11 Dec 2017 11:57:05 +0100

opentoonz-dmo (1.1.3-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 07 Jun 2017 08:46:51 +0200

opentoonz-dmo (1.1.2-dmo2) unstable; urgency=medium

  * Add multi-arch support.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 26 Dec 2016 09:15:22 +0100

opentoonz-dmo (1.1.2-dmo1) unstable; urgency=medium

  * Initial release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 17 Dec 2016 09:23:27 +0100
