=== debian/control ===
Source: opentoonz-dmo
Section: graphics
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://opentoonz.github.io/e/index.html
Standards-Version: 4.5.1
Build-Depends: debhelper-compat (= 13), dh-sequence-scour, cmake, libboost-dev,
 qtbase5-dev, libqt5svg5-dev, qtscript5-dev, qttools5-dev, qttools5-dev,
 libqt5opengl5-dev, qtmultimedia5-dev, libsuperlu-dev, liblz4-dev, qtbase5-dev,
 libusb-1.0-0-dev, liblzo2-dev, libpng-dev, libjpeg-dev, freeglut3-dev, libsdl2-dev,
 libfreetype-dev, libmypaint-dev (>= 1:1.6.1~), libglew-dev (>= 2.1.0~),
 libqt5serialport5-dev, libopencv-dev, libturbojpeg0-dev

Package: opentoonz
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, opentoonz-data (= ${source:Version})
Description: full-featured 2D animation creation software
 This is software for producing a 2D animation.
 .
 It is based on the software "Toonz", which was developed by Digital Video
 S.p.A. in Italy, customized by Studio Ghibli, and has been used for
 creating its works for many years.
 Dwango launches this OpenToonz project, in cooperation with Digital Video
 and Studio Ghibli.

Package: opentoonz-data
Architecture: all
Depends: ${misc:Depends}
Description: Open-source full-featured 2D animation creation software (data package)
 This is software for producing a 2D animation.
 .
 It is based on the software "Toonz", which was developed by Digital Video
 S.p.A. in Italy, customized by Studio Ghibli, and has been used for
 creating its works for many years.
 Dwango launches this OpenToonz project, in cooperation with Digital Video
 and Studio Ghibli.
 .
 (This package contains the data files).
